WINEMAKER(1)

NAME
winemaker - generate a build infrastructure for compiling Windows programs on Unix

SYNOPSIS
winemaker [ --nobanner ] [ --backup | --nobackup ] [ --nosource-fix ]
  [ --lower-none | --lower-all | --lower-uppercase ]
  [ --lower-include | --nolower-include ]
  [ --guiexe | --windows | --cuiexe | --console | --dll | --nodlls ]
  [ --wrap | --nowrap ] [ --mfc | --nomfc ]
  [ -Dmacro[=defn] ] [ -Idir ] [ -Ldir ] [ -idll] [ -llibrary ]
  [ --interactive ] [ --single-target name ]
  [ --generated-files ] [ --nogenerated-files ] [ --nogenerated-specs ]

DESCRIPTION

winemaker is a perl script designed to help you bootstrap the process of converting your Windows sources to Winelib programs.

In order to do this winemaker can perform the following operations:

- rename your source files and directories to lowercase in the event they got all uppercased during the transfer.

- perform Dos to Unix (CRLF to LF) conversions.

- scan the include statements and resource file references to replace the backslashes with forward slashes.

- during the above step winemaker will also perform a case insensitive search of the referenced file in the include path and rewrite the include statement with the right case if necessary.

- winemaker will also check other more exotic issues like '#pragma pack' usage, use of "afxres.h" in non MFC projects, and more. Whenever it encounters something out of the ordinary, winemaker will warn you about it.

- winemaker can also scan a complete directory tree at once, guess what are the executables and libraries you are trying to build, match them with source files, and generate the corresponding Makefile.in files.

- finally winemaker will generate a global Makefile.in file calling out to all the others, and a configure script customized for use with Winelib.

- winemaker knows about MFC-based project and will generate customized files.

OPTIONS

--nobanner
    Disables the printing of the banner.

--backup
    Directs winemaker to perform a backup of all the source files in which it makes changes. This is the default.

--nobackup
    Tells winemaker not to backup modified source files.

--nosource-fix
    Directs winemaker not to try fixing the source files (e.g. Dos to Unix conversion). This prevents complaints if the files are readonly.

--lower-all
    Tells winemaker to rename all files and directories to lowercase.

--lower-uppercase
    Tells winemaker to only rename files and directories that have an all uppercase name. So "HELLO.C" would be renamed but not "World.c".

--lower-none
    Tells winemaker not to rename files and directories to lower case. Note that this does not prevent the renaming of a file if its extension cannot be handled as is, e.g. ".Cxx". This is the default.

--lower-include
    Tells winemaker that if it does not find the file corresponding to an include statement (or other form of file reference for resource files), then it should convert that filename to lowercase. This is the default.

--nolower-include
    Tells winemaker not to modify the include statement if it cannot find the referenced file.

--guiexe | --windows
    Specifies that whenever winemaker finds an executable target, or a target of unknown type, it should assume that it is a graphical application. This is the default.

--cuiexe | --console
    Specifies that whenever winemaker finds an executable target, or a target of unknown type, it should assume that it is a console application.

--dll
    This option tells winemaker that whenever it finds a target of unknown type, i.e. for which it does not know whether it is an executable or a library, it should assume it is a library.

--nodlls
    This option tells winemaker not to use the standard set of winelib libraries for imports. That is, any DLL your code uses must be explicitly passed to winemaker with -i options. The standard set of libraries is: advapi32.dll, comdlg32.dll, gdi32.dll, kernel32.dll, odbc32.dll, ole32.dll, oleaut32.dll, shell32.dll, user32.dll, winspool.drv.

--wrap
    Specifies that executable targets should be built as libraries and a small executable wrapper generated for them. This technique is sometimes required to solve initialization problems occurring on the application startup.

--nowrap
    Specifies that no wrapper should be generated for executable targets. This is the default.

--mfc
    Specifies that the targets are MFC based. In such a case winemaker generates a configure script with MFC specific options, modifies the include and library paths accordingly, links the target with the MFC library and generates wrappers for these targets that are executables.

--nomfc
    Specifies that targets are not MFC-based. This option disables use of MFC libraries even if winemaker encounters files "stdafx.cpp" or "stdafx.h" that would cause it to enable MFC automatically if neither --nomfc nor --mfc was specified.

-Dmacro[=defn]
    Adds the specified macro definition to the global list of macro definitions.

-Idir
    Appends the specified directory to the global include path.

-Ldir
    Appends the specified directory to the global library path.

-idll
    Adds the Winelib library to the global list of Winelib libraries to import.

-llibrary
    Adds the specified library to the global list of libraries to link with.

--interactive
    Puts winemaker in interactive mode. In this mode winemaker will ask you to confirm each directory's list of targets, and then to provide directory and target specific options.

--single-target name
    Specifies that there is only one target, and that it is called "name".

--generated-files
    Tells winemaker to generate the build infrastructure files, i.e. the spec files, the wrapper files, the Makefile.in files, the Make.rules.in file, the configure.in file and the configure script. This is the default.

--nogenerated-files
    Tells winemaker not to generate any of the above files.

--nogenerated-specs
    Tells winemaker not to generate the spec files when generating files. This is particularly useful when using winemaker to generate a build environment and you already have a spec file.

EXAMPLES

Here is a typical winemaker use:

$ winemaker --lower-uppercase -DSTRICT

The above tells winemaker to scan the current directory and its subdirectories for source files. Whenever if finds a file or directory which name is all uppercase, it should rename it to lowercase. It should then fix all these source files for compilation with Winelib and generate Makefiles. The '-DSTRICT' specifies that the STRICT macro must be set when compiling these sources. Finally winemaker will create a global Makefile.in and configure.in, and run autoconf to generate the configure script.

The next step would be:

$ ./configure --with-wine=/usr/local/opt/wine

This generates the makefiles from the Makefile.in files. The generated makefiles will fetch the Winelib headers and libraries from the Wine installation located in /usr/local/opt/wine.

And finally:

$ make

If at this point you get compilation errors (which is quite likely for a reasonably sized project) then you should consult the Winelib User Guide to find tips on how to resolve them.

For an MFC-based project one would have run the following commands instead:

$ winemaker --lower-uppercase --mfc
$ ./configure --with-wine=/usr/local/opt/wine \
              --with-mfc=/usr/local/opt/mfc
$ make

TODO / BUGS

Winemaker should support the Visual Studio project files (.dsp for newer versions and .mak for some older versions). This would allow it to be much more accurate, especially for the macro, include and library path settings.

Assuming that the windows executable/library is available, we could use a pedump-like tool to determine what kind of executable it is (graphical or console), which libraries it is linked with, and which functions it exports (for libraries). We could then restore all these settings for the corresponding Winelib target. The problem is that we should have such a tool available under the Wine license first.

The wrapper code should be generic, i.e. you should be able to have just one wrapper and specify which library to load using an option.

Furthermore it is not very good at finding the library containing the executable: it must either be in the current directory or in the LD_LIBRARY_PATH.

Winemaker does not support message files and the message compiler yet.

SEE ALSO

The Winelib User Guide:

http://wine.codeweavers.com/docs/winelib-user/

wine(1)

AUTHOR
Francois Gouget <fgouget@codeweavers.com> for CodeWeavers